//
// RoboForm JS/XML code.
// Original code: Siber Systems Inc.
// Sam <spase@siber.com>
//
// Many thanks to Contributors:
//
// Daniel Einspanjer <daniel@yipyip.com> - toolbarpalette part
//
var rfn_logoff="";
var rfn_fillforms="" ;
var rfn_roboformtoolbar="" ;
var rfn_setfields="" ;
var rfn_resetfields="" ;
var rfn_clearfields="" ;
var rfn_options="" ;
var rfn_passgen="" ;
var rfn_identities="" ;
var rfn_passcards="" ;
var rfn_safenotes="" ;
var rfn_saveforms="" ;
var rfn_customizemenu="" ;
var roboformVendor=""
var roboformVendorSub=""
var roboformDisableDownloadPrompt=false;
var roboformErrormessage='Download Roboform';
var roboformErrormessageTooltip='Download and Install Siber Systems AI Roboform';
var rfadapter_contractid='@mozilla.org/rfproxy;31';

var roboformFiller;
var roboformToolbarContainer;

// Resize object encapsulating all resize related functions and properties
function roboformToolbarContainerResize() {
	this.MIN_WIDTH = 12;

	this.startX = 0;
	this.startY = 0;
	this.sLen = 0;
	this.dragging = false;
	this.isLeft = false;			// Which grippy is being dragged

	this.rftcBox = function () {
		return document.getElementById("rftc-container");
	}
	this.rftcHolder = document.getElementById("roboform-bar-holder");

	// Initialize the maxWidth property if it doesn't exist so that arithmetic involving it behaves properly.
	if (this.rftcBox().maxWidth == '') this.rftcBox().maxWidth = this.MIN_WIDTH;

	this.startDrag = function (isLeft, aEvent) {
		// Can't use 'this' in event context because 'this' is the main window.
		var resize = roboformToolbarContainer;
		if (aEvent.button == 0)	{
			resize.startX = aEvent.clientX;
			resize.startY = aEvent.clientY;
			resize.dragging = true;
			resize.isLeft = isLeft;

			resize.sLen = parseInt(resize.rftcBox().maxWidth);  //store original width for calculations

			addEventListener("mousemove", resize.whileDrag, true);
			addEventListener("mouseup", resize.endDrag, true);
		}
	};

	this.whileDrag = function (aEvent) {
		// Can't use 'this' in event context because 'this' is the main window.
		var resize = roboformToolbarContainer;
		if (resize.dragging) {
			var dX = aEvent.clientX - resize.startX;
			var dY = aEvent.clientY - resize.startY;

			// If this is the left grippy we want to expand the left side of the container
			if (!resize.isLeft) dX *= -1;

			var newWidth = resize.sLen - dX;
			if (newWidth > resize.MIN_WIDTH) {
				resize.rftcHolder.width = newWidth;
				resize.rftcBox().maxWidth = newWidth;
				resize.rftcBox().width = newWidth;
				}
		}	else resize.abort();
	};

	this.endDrag = function (aEvent) {
		// Can't use 'this' in event context because 'this' is the main window.
		var resize = roboformToolbarContainer;
		resize.abort();
	};

	this.abort = function ()	{
		this.dragging = false;
		removeEventListener("mousemove", this.whileDrag, true);
		removeEventListener("mouseup", this.endDrag, true);
	};
}

function InitRoboToolbar() {
	var item=null;
	var RfVersion = 0;
	try {
	    RfVersion = roboformFiller.rfVersion;
	} catch (e) {
	}

	if (RfVersion == 0) {
		if (roboformDisableDownloadPrompt) {
			item = null;
			item = document.getElementById("roboform-bar");
			if (item) item.setAttribute("hidden","true");

			item = null;
			item = document.getElementById("rftc-container");
			if (item) item.setAttribute("hidden","true");
		} else {
			item = null;
			item = document.getElementById("roboform-bar");
			if (item) item.setAttribute("hidden","false");

			item = null;
			item = document.getElementById("rftc-container");
			if (item) item.setAttribute("hidden","false");

			item = null;
			item = document.getElementById("rfshowbar-button");
			if (item) {
				item.setAttribute("hidden","false");
				item.setAttribute("label", roboformErrormessage);
				item.setAttribute("tooltiptext", roboformErrormessageTooltip);
			}

			item = null;
			item = document.getElementById("roboform-bar-holder");
			if (item) {
				var this_width = item.getAttribute("width");
				if (this_width > 1024) this_width = "1024";
				if (this_width < 12) this_width = "12";
				item.setAttribute("width", this_width);
				item.setAttribute("hidden","false");
			}

			item = null;
			item = document.getElementById("rfshowbar-toolbarbutton");
			if (item) {
				item.setAttribute("label", roboformErrormessage);
				item.setAttribute("tooltiptext", roboformErrormessageTooltip);
				RoboCloseToolBar();
			}
		}

		return;

	}

	if (RfVersion < 60000) {
		item = null;
		item = document.getElementById("roboform-bar");
		if (item) item.setAttribute("hidden","false");

		item = null;
		item = document.getElementById("rfshowbar-button");
		if (item) {
			item.setAttribute("hidden","false");
			item.setAttribute("label", "Unsupported browser");
			item.setAttribute("tooltiptext", "Click for more details");
		}

		item = null;
		item = document.getElementById("rftc-container");
		if (item) item.setAttribute("hidden","false");

		item = null;
		item = document.getElementById("roboform-bar-holder");
		if (item) {
			var this_width = item.getAttribute("width");
			if (this_width > 1024) this_width = "1024";
			if (this_width < 12) this_width = "12";
			item.setAttribute("width", this_width);
			item.setAttribute("hidden","false");
		}

		item = null;
		item = document.getElementById("rfshowbar-toolbarbutton");
		if (item) {
			item.setAttribute("label", "Unsupported Browser");
			item.setAttribute("tooltiptext", "Click for more details");
		}

		return;

	}

	item = null;
	item = document.getElementById("rfshowbar-button");
	if (item) {
		// item.setAttribute("hidden","false");
		item.setAttribute("label","Roboform Toolbar");
		item.setAttribute("tooltiptext", "Show/Hide RoboForm Toolbar");
	}

	item = null;
	item = document.getElementById("rfshowbar-toolbarbutton");
	if (item) {
		item.setAttribute("label","Roboform Toolbar");
		item.setAttribute("tooltiptext", "Show/Hide RoboForm Toolbar");
		RoboCloseToolBar();
	}

	// item = null;
	// item = document.getElementById("rfclosebar-button");
	// if (item) item.setAttribute("hidden","false");

	item = null;
	item = document.getElementById("roboform-bar");
	if (item) item.setAttribute("hidden","false");

	item = null;
	item = document.getElementById("roboform-bar-holder");
	if (item) {
		var this_width = item.getAttribute("width");
		if (this_width > 1024) this_width = "1024";
		if (this_width < 12) this_width = "12";
		item.setAttribute("width", this_width);
		item.setAttribute("hidden","false");
	}

	item = null;
	item = document.getElementById("rftc-container");
	if (item) item.setAttribute("hidden","false");

}

function roboformInitRContextItems() {
	var thisLocale=roboformFiller.locale;
	roboformFillLocale(thisLocale);
	var item = null;

	item = null;
	item = document.getElementById("context-robotoolbar");
	if (item) item.setAttribute("label", rfn_roboformtoolbar);
	
	item = null;
	item = document.getElementById("context-robologoff");
	if (item) item.setAttribute("label", rfn_logoff);
	
	item = null;
	item = document.getElementById("context-roboclearfields");
	if (item) item.setAttribute("label",rfn_clearfields);
	
	item = null;
	item = document.getElementById("context-robocustomizeiemenu");
	if (item) item.setAttribute("label",rfn_customizemenu);
	
	item = null;
	item = document.getElementById("context-robofillforms");
	if (item) item.setAttribute("label",rfn_fillforms);
	
	item = null;
	item = document.getElementById("context-roboeditident");
	if (item) item.setAttribute("label",rfn_identities);
	
	item = null;
	item = document.getElementById("context-roboeditpass");
	if (item) item.setAttribute("label",rfn_passcards);
	
	item = null;
	item = document.getElementById("context-robopasswordgenerator");
	if (item) item.setAttribute("label",rfn_passgen);
	
	item = null;
	item = document.getElementById("context-roboresetfields");
	if (item) item.setAttribute("label",rfn_resetfields);
	
	item = null;
	item = document.getElementById("context-robooptions");
	if (item) item.setAttribute("label",rfn_options);
	
	item = null;
	item = document.getElementById("context-roboeditnote");
	if (item) item.setAttribute("label",rfn_safenotes);
	
	item = null;
	item = document.getElementById("context-robosavepass");
	if (item) item.setAttribute("label",rfn_saveforms);
	
	item = null;
	item = document.getElementById("context-robosetfields");
	if (item) item.setAttribute("label",rfn_setfields);
	
	item = null;
	item = document.getElementById("context-robotaskbaricon");
	if (item) item.setAttribute("label",rfn_taskbar);
	
	var showState = false;
	var somethingVisible = false;

	somethingVisible |= showState = roboformGetEnabled(3);
	roboShowItem("context-robologoff", showState);

	somethingVisible |= showState = roboformGetEnabled(5);
	roboShowItem("context-roboclearfields", showState);

	somethingVisible |= showState = roboformGetEnabled(6);
	roboShowItem("context-robocustomizeiemenu", showState);

	somethingVisible |= showState = roboformGetEnabled(7);
	roboShowItem("context-robofillforms", showState);

	somethingVisible |= showState = roboformGetEnabled(10);
	roboShowItem("context-robofillsubmit", showState);

	somethingVisible |= showState = roboformGetEnabled(11);
	roboShowItem("context-robofillwithoutasking", showState);

	somethingVisible |= showState = roboformGetEnabled(12);
	roboShowItem("context-roboeditident", showState);

	somethingVisible |= showState = roboformGetEnabled(13);
	roboShowItem("context-roboeditpass", showState);

	somethingVisible |= showState = roboformGetEnabled(14);
	roboShowItem("context-robopasswordgenerator", showState);

	somethingVisible |= showState = roboformGetEnabled(15);
	roboShowItem("context-roboresetfields", showState);

	somethingVisible |= showState = roboformGetEnabled(16);
	roboShowItem("context-robooptions", showState);

	somethingVisible |= showState = roboformGetEnabled(17);
	roboShowItem("context-robotaskbaricon", showState);

	somethingVisible |= showState = roboformGetEnabled(18);
	roboShowItem("context-roboeditnote", showState);

	somethingVisible |= showState = roboformGetEnabled(19);
	roboShowItem("context-robosavepass", showState);

	somethingVisible |= showState = roboformGetEnabled(20);
	roboShowItem("context-robosetfields", showState);

	somethingVisible |= showState = roboformGetEnabled(21);
	roboShowItem("context-robotoolbar", showState);

	roboShowItem("context-roboseparator", somethingVisible);

	// This is always shown...
	// roboShowItem("context-robocustomize", true);
}

function RoboWindowOnLoad() {
	//Add listener on event when bwowser context menu popup
	try {
		document.getElementById('contentAreaContextMenu').addEventListener('popupshowing', roboformInitRContextItems, false);
	} catch (e) {}
	RoboStart();
}

function RoboStart() {
	var holder = document.getElementById("roboform-bar-holder");
	if (holder) {	
		if (roboformToolbarContainer==undefined || roboformToolbarContainer==null) {
			roboformToolbarContainer = new roboformToolbarContainerResize();
		}
	}

	if (roboformFiller==undefined || roboformFiller == null) {
		var componentRegistrar;
		componentRegistrar = Components.manager.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		if (componentRegistrar != undefined) {
			if (!(componentRegistrar.isContractIDRegistered(rfadapter_contractid))) {
				componentRegistrar.autoRegister(null);
			}
			if (!componentRegistrar.isContractIDRegistered(rfadapter_contractid)) {
				roboformErrormessage = "Error: Cannot register rfproxy component.";
				roboformErrormessageTooltip = "Error: Cannot register rfproxy component. "+rfadapter_contractid;
			}
		} else {
			roboformErrormessage = "Error: Cannot access Component Manager.";
			roboformErrormessageTooltip = "Error: Cannot access Component Manager.";
		}
		try {
		    roboformFiller = Components.classes[rfadapter_contractid].createInstance();
		    roboformFiller = roboformFiller.QueryInterface(Components.interfaces.nsIRFProxy3);
		    roboformFiller.setJarVersion("6-10-1");
		} catch(e) {
		}
	}
	InitRoboToolbar();
	roboformFiller.processBrowsersTree(document);
}

function RoboGoFill() {
	roboformFiller.comGoFill(window._content.document);
}

function RoboGoFillSubmit() {
	roboformFiller.comGoFillSubmit(window._content.document);
}

function RoboLogoff() {
	roboformFiller.comLogoff(window._content.document);
}

function RoboCheckForms() {
	roboformFiller.comCheckForms(window._content.document);
}

function RoboClearFields() {
	roboformFiller.comClearFields(window._content.document);
}

function RoboCustomizeIEMenu() {
	roboformFiller.comCustomizeIEMenu(window._content.document);
}

function RoboFillForms() {
	roboformFiller.comFillForms(window._content.document);
}

function RoboFillIdent() {
	roboformFiller.comFillIdent(window._content.document);
}

function RoboFillPass() {
	roboformFiller.comFillPass(window._content.document);
}

function RoboFillSubmit() {
	roboformFiller.comFillSubmit(window._content.document);
}

function RoboFillWithoutAsking() {
	roboformFiller.comFillWithoutAsking(window._content.document);
}

function RoboEditIdent() {
	roboformFiller.comEditIdent(window._content.document);
}

function RoboEditPass() {
	roboformFiller.comEditPass(window._content.document);
}

function RoboPasswordGenerator() {
	roboformFiller.comPasswordGenerator(window._content.document);
}

function RoboResetFields() {
	roboformFiller.comResetFields(window._content.document);
}

function RoboOptions() {
	roboformFiller.comOptions(window._content.document);
}

function RoboTaskBarIcon() {
	roboformFiller.comTaskBarIcon(window._content.document);
}

function RoboEditNote() {
	roboformFiller.comEditNote(window._content.document);
}

function RoboSavePass() {
	roboformFiller.comSavePass(window._content.document);
}

function RoboSetFields() {
	roboformFiller.comSetFields(window._content.document);
}

function RoboShowToolBar() {
	var RfVersion = 0;
	try {
	    RfVersion = roboformFiller.rfVersion;
	} catch (e) {
	}

	if (RfVersion == 1) {
		var alertText = "This Adapter (6-10-1) supports only Firefox ver. 3.0";
		if ("3.0" != "4.1") {
			alertText = alertText + " to 4.1";
		}
		alertText = alertText + ".\nYou are using ";
		alertText = alertText + roboformVendor;
		alertText = alertText + " ver. ";
		alertText = alertText + roboformVendorSub;
		alertText = alertText + '\nClick "Ok" to go to web page that explains how to install RoboForm Adapter as extension.'
		var rc = confirm(alertText);
		if (rc) RoboNewWindow("http://www.roboform.com/browsers.html#browser_mozilla");
		return;
	}

	if (RfVersion < 60000) {
		RoboNewWindow("http://www.roboform.com/download.html?adapter=yes");
		return;
	}
	
	roboformFiller.processBrowsersTree(document);
	roboformFiller.comShowToolBar(window._content.document);
}

function roboformIsCustomizableToolbar(aElt)
{
  return aElt.localName == "toolbar" &&
         aElt.getAttribute("customizable") == "true";
}

//
//Persist the current set of buttons in TargetToolbar to localstore.
//
function roboformPersistCurrentSet(toolbox, TargetToolbar)
{
	var gToolbox = toolbox;
	var gToolboxDocument = gToolbox.ownerDocument;
	
	var customCount = 0;
	var customIndex;
	//looking for TargetToolbar
	for (var i = 0; i < gToolbox.childNodes.length; ++i) {
		// Look for customizable toolbars that need to be persisted.
		var toolbar = gToolbox.childNodes[i];
		if (roboformIsCustomizableToolbar(toolbar)) {
			customIndex = toolbar.hasAttribute("customindex");
			if(customIndex)
				customCount++;
			if(toolbar==TargetToolbar)
				break;
		}
	}
	//if we have found toolbar
	if(i != gToolbox.childNodes.length) {
		var currentSet = TargetToolbar.currentSet;
		toolbar.setAttribute("currentset", currentSet);

		if(customIndex) {
			//Persist custom toolbar info on the <toolbarset/>
			gToolbox.toolbarset.setAttribute("toolbar"+customCount,
				TargetToolbar.toolbarName + ":" + currentSet);
			gToolboxDocument.persist(gToolbox.toolbarset.id, "toolbar"+customCount);
		}
		else {
			// Persist the currentset attribute directly on hardcoded toolbars.
			gToolboxDocument.persist(TargetToolbar.id, "currentset");
		}
	}
}

//
//Toggle toolbar state (Enable/Disable)
//
function RoboSwitchToolbar() {
	var aToolbarItem = document.getElementById("rftc-container");
	if(aToolbarItem) {
		var toolbar = aToolbarItem.parentNode;
 		if(toolbar) {
			toolbar.removeChild(aToolbarItem);
			//persist changes
			roboformPersistCurrentSet(toolbar.parentNode, toolbar);
		}
		return;
	}
	var item = document.getElementById("roboform-bar");
	if (item) {
		var bClosed = item.hidden || item.collapsed;
		if(bClosed)
			item.hidden = !bClosed;
		item.collapsed = !bClosed;
	}
}

function RoboCloseToolBar() {
	var item = document.getElementById("roboform-bar");
	if (item) item.setAttribute("collapsed","true");
}

function roboformGetEnabled(name) {
	var value = roboformFiller.getEnabled(name);
	if (value==1) {
		return true;
	}
	return false;
}

function roboShowItem(itemOrId, show) {
	var item = null;
	item = document.getElementById(itemOrId);

	if (item) item.setAttribute("hidden", !show);
}

function roboformGetId(ord) {
	var value = roboformFiller.getIdentity(ord);
	return value;
}

function roboformGetPbe(ord) {
	var value = roboformFiller.getPassCard(ord);
	return value;
}

function deleteRoboItems(aParent) {
	var children = aParent.childNodes;
	for (var i = 0; i < children.length; i++ ) {
		var index = children[i].getAttribute( "index" );
		if (index) aParent.removeChild( children[i] );
	}
}

function RoboIdsMenu(event) {
	deleteRoboItems(event.target);
	var j;
	var entry;
	j=0;
	while(true) {
		entry = roboformGetId(j);
		if (entry) createMenuItem(event.target, j, entry); else break;
		j++;
	}
	return true;
}

function RoboPbeMenu(event) {
	deleteRoboItems(event.target);
	var j;
	var entry;
	j=0;
	while(true) {
		entry = roboformGetPbe(j);
		if (entry) createMenuItem(event.target, j, entry); else break;
		j++;
	}
	return true;
}

function RoboSetID(aEvent) {
	var thisID = aEvent.target.getAttribute("label");
	if (!thisID) return false;

	roboformFiller.currentID = thisID;

	var item = null;
	item = document.getElementById("rfeditid-button");

	if (item) item.setAttribute("label",thisID);

	return true;
}

function RoboSetPBE(aEvent) {
	var thisID = aEvent.target.getAttribute("label");
	if (!thisID) return false;

	roboformFiller.currentPBE = thisID;

	var item = null;
	item = document.getElementById("rfeditpbe-button");

	if (item) item.setAttribute("label",thisID);

	return true;
}

function RoboNewWindow(href) {
	return openNewWindowWith(href, null, null, false);
}

function RoboNewTab(href) {
	return openNewTabWith(href, null, null, true, null);
}

function RoboOpener() {
	var item = null;
	item = document.getElementById("rfopener-button");
	if (!item) return false;
	var href = item.getAttribute("href");
	return RoboNewTab(href);
}
